package serializers;

import com.vividsolutions.jts.geom.Geometry;
import flexjson.JSONSerializer;
import utils.SerializerUtil;
import utils.flexjson.GeometryTransformer;

import java.util.Date;

public class ProcessoSerializer {
	
	public static JSONSerializer list = SerializerUtil.create(
			"id",
			"numero",
			"empreendimento.municipio.nome",
			"empreendimento.municipio.estado.codigo",
			"empreendimento.empreendimentoEU.cpfCnpj",
			"empreendimento.empreendimentoEU.cpfCnpjCadastrante",
			"objetoTramitavel",
			"empreendimento.empreendimentoEU.denominacao");

	public static JSONSerializer getInfo = SerializerUtil.create(
			"id",
			"numero",
			"tiposLicenca",
			"idObjetoTramitavel",
			"renovacao",
			"analise.id",
			"analise.dataCadastro",
			"analise.dataVencimentoPrazo",
			"analise.diasAnalise.qtdeDiasGeo",
			"analise.diasAnalise.qtdeDiasTecnica",
			"analise.diasAnalise.qtdeDiasAnalise",
			"analise.analiseGeo.id",
			"analise.analiseGeo.pareceresGerenteAnaliseGeo.id",
			"analise.analiseGeo.pareceresGerenteAnaliseGeo.tipoResultadoAnalise.id",
			"analise.analiseGeo.pareceresGerenteAnaliseGeo.tipoResultadoAnalise.nome",
			"analise.analiseGeo.pareceresGerenteAnaliseGeo.parecer",
			"analise.analiseGeo.pareceresGerenteAnaliseGeo.usuario.pessoa.nome",
			"analise.analiseGeo.pareceresGerenteAnaliseGeo.dataParecer",
			"analise.analiseTecnica.id",
			"analise.analiseTecnica.pareceresGerenteAnaliseTecnica.id",
			"analise.analiseTecnica.pareceresGerenteAnaliseTecnica.tipoResultadoAnalise.id",
			"analise.analiseTecnica.pareceresGerenteAnaliseTecnica.tipoResultadoAnalise.nome",
			"analise.analiseTecnica.pareceresGerenteAnaliseTecnica.parecer",
			"analise.analiseTecnica.pareceresGerenteAnaliseTecnica.usuario.pessoa.nome",
			"analise.analiseTecnica.pareceresGerenteAnaliseTecnica.dataParecer",
			"analise.analiseTecnica.pareceresAnalistaTecnico.id",
			"analise.analiseTecnica.pareceresAnalistaTecnico.tipoResultadoAnalise.id",
			"analise.analiseTecnica.pareceresAnalistaTecnico.tipoResultadoAnalise.nome",
			"analise.analiseTecnica.pareceresAnalistaTecnico.parecer",
			"analise.analiseTecnica.pareceresAnalistaTecnico.analistaTecnico.pessoa.nome",
			"analise.analiseTecnica.pareceresAnalistaTecnico.dataParecer",
			"analise.analiseTecnica.pareceresAnalistaTecnico.cartaImagem.id",
			"analise.analiseTecnica.pareceresAnalistaTecnico.cartaImagem.nomeDoArquivo",
			"analise.analiseTecnica.pareceresAnalistaTecnico.cartaImagem.tipo.nome",
			"analise.analiseTecnica.pareceresAnalistaTecnico.cartaImagem.responsavel",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoParecer.id",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoParecer.nomeDoArquivo",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoParecer.tipo.nome",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoParecer.responsavel",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoMinuta.id",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoMinuta.nomeDoArquivo",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoMinuta.tipo.nome",
			"analise.analiseTecnica.pareceresAnalistaTecnico.documentoMinuta.responsavel",
			"analise.analiseTecnica.pareceresAnalistaTecnico.vistoria.documentoRelatorioTecnicoVistoria.id",
			"analise.analiseTecnica.pareceresAnalistaTecnico.vistoria.documentoRelatorioTecnicoVistoria.nomeDoArquivo",
			"analise.analiseTecnica.pareceresAnalistaTecnico.vistoria.documentoRelatorioTecnicoVistoria.tipo.nome",
			"analise.analiseTecnica.pareceresAnalistaTecnico.vistoria.documentoRelatorioTecnicoVistoria.responsavel",
			"analise.analiseGeo.pareceresAnalistaGeo.id",
			"analise.analiseGeo.pareceresAnalistaGeo.tipoResultadoAnalise.id",
			"analise.analiseGeo.pareceresAnalistaGeo.tipoResultadoAnalise.nome",
			"analise.analiseGeo.pareceresAnalistaGeo.parecer",
			"analise.analiseGeo.pareceresAnalistaGeo.usuario.pessoa.nome",
			"analise.analiseGeo.pareceresAnalistaGeo.dataParecer",
			"analise.analiseGeo.pareceresAnalistaGeo.documentoParecer.id",
			"analise.analiseGeo.pareceresAnalistaGeo.documentoParecer.nomeDoArquivo",
			"analise.analiseGeo.pareceresAnalistaGeo.documentoParecer.tipo.nome",
			"analise.analiseGeo.pareceresAnalistaGeo.documentoParecer.responsavel",
			"analise.analiseGeo.pareceresAnalistaGeo.cartaImagem.id",
			"analise.analiseGeo.pareceresAnalistaGeo.cartaImagem.nomeDoArquivo",
			"analise.analiseGeo.pareceresAnalistaGeo.cartaImagem.tipo.nome",
			"analise.analiseGeo.pareceresAnalistaGeo.cartaImagem.responsavel",
			"analise.analiseJuridica.id",
			"analise.analisesJuridica.dataVencimentoPrazo",
			"analise.analisesJuridica.dataInicio",
			"analise.analisesJuridica.dataFim",
			"analise.analisesGeo.dataVencimentoPrazo",
			"analise.analisesGeo.dataInicio",
			"analise.analisesGeo.dataFim",
			"analise.analisesTecnicas.dataCadastro",
			"analise.analisesTecnicas.id",
			"analise.analisesTecnicas.justificativaCoordenador",
			"analise.analisesTecnicas.dataFim",
			"analise.analisesTecnicas.dataVencimentoPrazo",
			"analise.analisesTecnicas.pareceresChefeUnidadeAnaliseTecnica.id",
			"analise.analisesTecnicas.pareceresChefeUnidadeAnaliseTecnica.tipoResultadoAnalise.id",
			"analise.analisesTecnicas.pareceresChefeUnidadeAnaliseTecnica.tipoResultadoAnalise.nome",
			"analise.analisesTecnicas.pareceresChefeUnidadeAnaliseTecnica.parecer",
			"analise.analisesTecnicas.pareceresChefeUnidadeAnaliseTecnica.usuario.pessoa.nome",
			"analise.analisesTecnicas.pareceresChefeUnidadeAnaliseTecnica.dataParecer",
			"processoAnterior.id",
			"processoAnterior.historicoTramitacao.idHistorico",
			"processoAnterior.historicoTramitacao.dataInicial",
			"processoAnterior.historicoTramitacao.dataFinal",
			"processoAnterior.historicoTramitacao.nomeUsuarioDestino",
			"processoAnterior.historicoTramitacao.nomeUsuarioExecutor",
			"processoAnterior.historicoTramitacao.idAcao",
			"processoAnterior.historicoTramitacao.nomeAcao",
			"processoAnterior.historicoTramitacao.idCondicaoInicial",
			"processoAnterior.historicoTramitacao.nomeCondicaoInicial",
			"processoAnterior.historicoTramitacao.idCondicaoFinal",
			"processoAnterior.historicoTramitacao.nomeCondicaoFinal",
			"processoAnterior.historicoTramitacao.tempoPermanencia",
			"processoAnterior.historicoTramitacao.hasNotificacoes",
			"processoAnterior.historicoTramitacao.documentosCorrigidos.id",
			"processoAnterior.historicoTramitacao.documentosCorrigidos.tipo.nome",
			"processoAnterior.historicoTramitacao.setor.nome",
			"processoAnterior.historicoTramitacao.setor.sigla",
			"processoAnterior.historicoTramitacaoAnterior.idHistorico",
			"processoAnterior.historicoTramitacaoAnterior.dataInicial",
			"processoAnterior.historicoTramitacaoAnterior.dataFinal",
			"processoAnterior.historicoTramitacaoAnterior.nomeUsuarioDestino",
			"processoAnterior.historicoTramitacaoAnterior.nomeUsuarioExecutor",
			"processoAnterior.historicoTramitacaoAnterior.idAcao",
			"processoAnterior.historicoTramitacaoAnterior.nomeAcao",
			"processoAnterior.historicoTramitacaoAnterior.idCondicaoInicial",
			"processoAnterior.historicoTramitacaoAnterior.nomeCondicaoInicial",
			"processoAnterior.historicoTramitacaoAnterior.idCondicaoFinal",
			"processoAnterior.historicoTramitacaoAnterior.nomeCondicaoFinal",
			"processoAnterior.historicoTramitacaoAnterior.tempoPermanencia",
			"processoAnterior.historicoTramitacaoAnterior.hasNotificacoes",
			"processoAnterior.historicoTramitacaoAnterior.documentosCorrigidos.id",
			"processoAnterior.historicoTramitacaoAnterior.documentosCorrigidos.tipo.nome",
			"processoAnterior.historicoTramitacaoAnterior.setor.nome",
			"processoAnterior.historicoTramitacaoAnterior.relHistoricoTramitacaoSetor.siglaSetor",
			"analise.pareceresDiretorTecnico.id",
			"analise.pareceresDiretorTecnico.usuario.pessoa.nome",
			"analise.pareceresDiretorTecnico.tipoResultadoAnalise.id",
			"analise.pareceresDiretorTecnico.tipoResultadoAnalise.nome",
			"analise.pareceresDiretorTecnico.parecer",
			"analise.pareceresDiretorTecnico.dataParecer",
			"analise.pareceresPresidente.id",
			"analise.pareceresPresidente.usuario.pessoa.nome",
			"analise.pareceresPresidente.tipoResultadoAnalise.id",
			"analise.pareceresPresidente.tipoResultadoAnalise.nome",
			"analise.pareceresPresidente.parecer",
			"analise.pareceresPresidente.dataParecer",
			"processoAnterior.analise.analisesTecnicas.id",
			"historicoTramitacao.idHistorico",
			"historicoTramitacao.dataInicial",
			"historicoTramitacao.dataFinal",
			"historicoTramitacao.nomeUsuarioDestino",
			"historicoTramitacao.nomeUsuarioExecutor",
			"historicoTramitacao.idAcao",
			"historicoTramitacao.nomeAcao",
			"historicoTramitacao.idCondicaoInicial",
			"historicoTramitacao.nomeCondicaoInicial",
			"historicoTramitacao.idCondicaoFinal",
			"historicoTramitacao.nomeCondicaoFinal",
			"historicoTramitacao.tempoPermanencia",
			"historicoTramitacao.hasNotificacoes",
			"historicoTramitacao.documentosCorrigidos.id",
			"historicoTramitacao.documentosCorrigidos.tipo.nome",
			"historicoTramitacao.setor.nome",
			"historicoTramitacao.setor.sigla",
			"historicoTramitacaoAnterior.idHistorico",
			"historicoTramitacaoAnterior.dataInicial",
			"historicoTramitacaoAnterior.dataFinal",
			"historicoTramitacaoAnterior.nomeUsuarioDestino",
			"historicoTramitacaoAnterior.nomeUsuarioExecutor",
			"historicoTramitacaoAnterior.idAcao",
			"historicoTramitacaoAnterior.nomeAcao",
			"historicoTramitacaoAnterior.idCondicaoInicial",
			"historicoTramitacaoAnterior.nomeCondicaoInicial",
			"historicoTramitacaoAnterior.idCondicaoFinal",
			"historicoTramitacaoAnterior.nomeCondicaoFinal",
			"historicoTramitacaoAnterior.tempoPermanencia",
			"historicoTramitacaoAnterior.hasNotificacoes",
			"historicoTramitacaoAnterior.documentosCorrigidos.id",
			"historicoTramitacaoAnterior.documentosCorrigidos.tipo.nome",
			"historicoTramitacaoAnterior.setor.nome",
			"historicoTramitacaoAnterior.relHistoricoTramitacaoSetor.siglaSetor",
			"empreendimento.id",
			"empreendimento.cpfCnpj",
			"empreendimento.cpfCnpjCadastrante",
			"empreendimento.empreendimentoEU.denominacao",
			"empreendimento.jurisdicao",
			"empreendimento.possuiShape",
			"empreendimento.municipio.nome",
			"empreendimento.municipio.estado.codigo",
			"empreendimento.municipio.id",
			"empreendimento.municipio.limite",
			"empreendimento.empreendimentoEU.contatos.id",
			"empreendimento.empreendimentoEU.contatos.valor",
			"empreendimento.empreendimentoEU.contatos.principal",
			"empreendimento.empreendimentoEU.contatos.tipo.id",
			"empreendimento.empreendimentoEU.contatos.tipo.descricao",
			"empreendimento.empreendimentoEU.pessoa.enderecos.logradouro",
			"empreendimento.empreendimentoEU.pessoa.enderecos.numero",
			"empreendimento.empreendimentoEU.pessoa.enderecos.complemento",
			"empreendimento.empreendimentoEU.pessoa.enderecos.bairro",
			"empreendimento.empreendimentoEU.pessoa.enderecos.correspondencia",
			"empreendimento.empreendimentoEU.pessoa.enderecos.cep",
			"empreendimento.empreendimentoEU.pessoa.enderecos.caixaPostal",
			"empreendimento.empreendimentoEU.pessoa.enderecos.municipio.nome",
			"empreendimento.empreendimentoEU.pessoa.enderecos.municipio.estado.sigla",
			"empreendimento.empreendimentoEU.pessoa.enderecos.roteiroAcesso",
			"empreendimento.empreendimentoEU.pessoa.enderecos.tipo.id",
			"empreendimento.empreendimentoEU.pessoa.enderecos.zonaLocalizacao.codigo",
			"empreendimento.empreendimentoEU.proprietarios.cpf",
			"empreendimento.empreendimentoEU.proprietarios.nome",
			"empreendimento.empreendimentoEU.proprietarios.dataNascimento",
			"empreendimento.empreendimentoEU.proprietarios.rg",
			"empreendimento.localizacao",
			"empreendimento.imovel.codigo",
			"empreendimento.imovel.idCar",
			"empreendimento.imovel.nome",
			"empreendimento.imovel.limite",
			"empreendimento.imovel.municipio.nome",
			"empreendimento.imovel.municipio.estado.nome",
			"empreendimento.area",
			"empreendimento.empreendimentoEU.localizacao.geometria",
			"empreendimento.empreendimentoEU.responsaveisLegais.cpf",
			"empreendimento.empreendimentoEU.responsaveisLegais.nome",
			"empreendimento.empreendimentoEU.responsaveisLegais.contatos.tipo.descricao",
			"empreendimento.empreendimentoEU.responsaveisLegais.contatos.tipo.id",
			"empreendimento.empreendimentoEU.responsaveisLegais.contatos.valor",
			"empreendimento.empreendimentoEU.responsaveisTecnicos.cpf",
			"empreendimento.empreendimentoEU.responsaveisTecnicos.nome",
			"empreendimento.empreendimentoEU.responsaveisTecnicos.contatos.tipo.descricao",
			"empreendimento.empreendimentoEU.responsaveisTecnicos.contatos.tipo.id",
			"empreendimento.empreendimentoEU.responsaveisTecnicos.contatos.valor",
			"empreendimento.empreendimentoEU.representantesLegais.cpf",
			"empreendimento.empreendimentoEU.representantesLegais.nome",
			"empreendimento.empreendimentoEU.representantesLegais.dataCadastro",
			"empreendimento.empreendimentoEU.representantesLegais.contatos.tipo.descricao",
			"empreendimento.empreendimentoEU.representantesLegais.contatos.tipo.id",
			"empreendimento.empreendimentoEU.representantesLegais.contatos.valor",
			"empreendimento.empreendimentoEU.empreendedor.id",
			"empreendimento.empreendimentoEU.empreendedor.dataCadastro",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.cpf",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.nome",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.nomeMae",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.rg.numero",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.dataNascimento",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.sexo.descricao",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.estadoCivil.nome",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.tituloEleitor",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.cnpj",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.razaoSocial",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.contatos.id",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.contatos.valor",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.contatos.principal",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.contatos.tipo.id",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.contatos.tipo.descricao",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.logradouro",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.numero",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.complemento",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.bairro",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.correspondencia",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.cep",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.caixaPostal",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.municipio.nome",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.municipio.estado.sigla",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.roteiroAcesso",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.tipo.id",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.tipo.descricao",
			"empreendimento.empreendimentoEU.empreendedor.pessoa.enderecos.zonaLocalizacao.codigo",
			"empreendimentoCamandasGeo.id",
			"empreendimentoCamandasGeo.tipoAreaGeometria.id",
			"empreendimentoCamandasGeo.tipoAreaGeometria.codigo",
			"empreendimentoCamandasGeo.tipoAreaGeometria.nome",
			"empreendimentoCamandasGeo.geometria",
			"objetoTramitavel.condicao.idCondicao",
			"objetoTramitavel.condicao.nomeCondicao",
			"caracterizacao.id",
			"caracterizacao.numero",
			"caracterizacao.documentosEnviados.id",
			"caracterizacao.documentosEnviados.nome",
			"caracterizacao.documentosEnviados.tipo.id",
			"caracterizacao.documentosEnviados.tipo.nome",
			"caracterizacao.atividadesCaracterizacao.documentosSolicitacaoGrupo.id",
			"caracterizacao.atividadesCaracterizacao.documentosSolicitacaoGrupo.documento.id",
			"caracterizacao.atividadesCaracterizacao.documentosSolicitacaoGrupo.tipoDocumento.id",
			"caracterizacao.atividadesCaracterizacao.documentosSolicitacaoGrupo.tipoDocumento.nome",
			"caracterizacao.tipo.nome",
			"caracterizacao.tipoLicenca.nome",
			"caracterizacao.licencas.dataValidade",
			"caracterizacao.atividadesCaracterizacao.isPrincipal",
			"caracterizacao.atividadesCaracterizacao.atividade",
			"caracterizacao.atividadesCaracterizacao.atividade.tipoEstudo",
			"caracterizacao.atividadesCaracterizacao.atividade.potencialPoluidor",
			"caracterizacao.atividadesCaracterizacao.atividade.potencialPoluidor.nome",
			"caracterizacao.atividadesCaracterizacao.atividade.potencialPoluidor.valorPpd",
			"caracterizacao.atividadesCaracterizacao.atividade.nome",
			"caracterizacao.atividadesCaracterizacao.atividade.tipologia.nome",
			"caracterizacao.atividadesCaracterizacao.atividade.tipologia.codigo",
			"caracterizacao.atividadesCaracterizacao.atividadeCaracterizacaoParametros.valorParametro",
			"caracterizacao.atividadesCaracterizacao.porteEmpreendimento.codigo",
			"caracterizacao.atividadesCaracterizacao.porteEmpreendimento.nome",
			"caracterizacao.atividadesCaracterizacao.atividade.parametros.nome",
			"caracterizacao.atividadesCaracterizacao.atividade.parametros.codigo",
			"caracterizacao.atividadesCaracterizacao.atividade.potencialPoluidor.valorPpd",
			"caracterizacao.atividadesCaracterizacao.porteEmpreendimento.nome",
			"caracterizacao.processoOutorga")
			.transform(GeometrySerializer.getTransformer(), Geometry.class)
			.exclude("*");

}
